//Copyright (C) KLA-Tencor (ASD Division),  1999. All rights reserved.   
// GIT.inl : implementation file
//

/////////////////// Error handling macros  ///////////////////////////
#define ASSERT_AND_RETURN(hres)        {\
                                          ATLASSERT(SUCCEEDED(hres)); \
                                          if(FAILED(hres))            \
                                             return hres;             \
                                       }


#ifdef _DEBUG
#define ASSERT_AND_THROW(hres)          ATLASSERT(SUCCEEDED(hres));     
#else
#define ASSERT_AND_THROW(hres)          if(FAILED(hres))             \
                                        {                            \
                                          AfxThrowOleException(hres);\
                                        }
#endif
//////////////////////////////////////////////////////////////////////
template <class Itf,const IID* piid>
inline CGlobalInterfaceTable<Itf,piid>::CGlobalInterfaceTable()
{
   HRESULT hres = S_OK;
   m_pGlobalInterfaceTable = NULL;

   hres = ::CoCreateInstance(CLSID_StdGlobalInterfaceTable,NULL,CLSCTX_INPROC_SERVER,IID_IGlobalInterfaceTable,(void**)&m_pGlobalInterfaceTable);
   ASSERT_AND_THROW(hres);
}

template <class Itf,const IID* piid>
inline CGlobalInterfaceTable<Itf,piid>::~CGlobalInterfaceTable()
{
   m_pGlobalInterfaceTable->Release();
}

template <class Itf,const IID* piid>
inline HRESULT CGlobalInterfaceTable<Itf,piid>::Register(Itf* pInterface,DWORD *pdwCookie)
{
   HRESULT hres = S_OK;

   hres = m_pGlobalInterfaceTable->RegisterInterfaceInGlobal(pInterface,*piid,pdwCookie);  
   ASSERT_AND_RETURN(hres);

   return S_OK;
}


template <class Itf,const IID* piid>
inline HRESULT CGlobalInterfaceTable<Itf,piid>::Revoke(DWORD dwCookie)
{
   HRESULT hres = S_OK;

   hres = m_pGlobalInterfaceTable->RevokeInterfaceFromGlobal(dwCookie);  
   ASSERT_AND_RETURN(hres);

   return S_OK;
}

template <class Itf,const IID* piid>
inline HRESULT CGlobalInterfaceTable<Itf,piid>::GetInterface(DWORD dwCookie,Itf** ppInterface)
{
   HRESULT hres = S_OK;

   hres = m_pGlobalInterfaceTable->GetInterfaceFromGlobal(dwCookie,*piid,(void**)ppInterface);  
   ASSERT_AND_RETURN(hres);

   return S_OK;
}


