// TraceComponentsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TraceComponents.h"
#include "TraceComponentsDlg.h"
#include "comdef.h"
#include "COMadmin.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTraceComponentsDlg dialog

CTraceComponentsDlg::CTraceComponentsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTraceComponentsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTraceComponentsDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTraceComponentsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTraceComponentsDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTraceComponentsDlg, CDialog)
	//{{AFX_MSG_MAP(CTraceComponentsDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_TRACE, OnTrace)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTraceComponentsDlg message handlers

BOOL CTraceComponentsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTraceComponentsDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTraceComponentsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTraceComponentsDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void TraceComponents(ICatalogCollection* pApplicationCollection,
                     ICatalogObject* pApplication)
{
   HRESULT hres = S_OK;
   ICatalogCollection* pComponentCollection = NULL;
   long nComponentCount = 0;
   _variant_t varAppKey;
   //Get the component collection for this application.Need the key first
   hres  = pApplication->get_Key(&varAppKey);
   hres = pApplicationCollection->GetCollection(_bstr_t("Components"),
                            varAppKey,(IDispatch**)&pComponentCollection);
   //Read the information from the catalog
   hres = pComponentCollection->Populate(); 
   hres = pComponentCollection->get_Count(&nComponentCount);

   for(int j=0;j<nComponentCount;j++)
   {  
      ICatalogObject* pComponent   = NULL;
      _variant_t varCompName;
      //Get the current component
      hres = pComponentCollection->get_Item(j,(IDispatch**)&pComponent);
      hres = pComponent->get_Name(&varCompName);
      CString sCompName = (BSTR)(_bstr_t(varCompName));//Ugly, but works
      TRACE("  %d. %s \n",j+1,sCompName);
      pComponent->Release();
   } 
   pComponentCollection->Release();
}
void TraceTree() 
{
   HRESULT hres = S_OK;
   ICOMAdminCatalog* pCatalog                 = NULL;
   ICatalogCollection* pApplicationCollection = NULL;
   long nApplicationCount = 0;
   
   hres = ::CoCreateInstance(CLSID_COMAdminCatalog,NULL,CLSCTX_ALL,
                             IID_ICOMAdminCatalog,(void**)&pCatalog);

   hres = pCatalog->GetCollection(_bstr_t("Applications"),
                                  (IDispatch**)&pApplicationCollection);
   pCatalog->Release(); //We don't need the root any more
   //Read the information from the catalog
   hres = pApplicationCollection->Populate(); 
   hres = pApplicationCollection->get_Count(&nApplicationCount);
   for(int i=0;i<nApplicationCount;i++)
   {  ICatalogObject* pApplication = NULL;
      ICatalogCollection* pComponentCollection = NULL;
      _variant_t varAppName;
      //Get the current application
      hres = pApplicationCollection->get_Item(i,(IDispatch**)&pApplication);
      hres = pApplication->get_Name(&varAppName);
      CString sAppName = (BSTR)(_bstr_t(varAppName)); //Ugly, but works
      TRACE("The components in application \"%s\" are: \n",sAppName);
      TraceComponents(pApplicationCollection,pApplication);
      pApplication->Release();
   }
   pApplicationCollection->Release();
}

void CTraceComponentsDlg::OnTrace() 
{
   TraceTree();	
}
