#ifndef _ADMINWRAP_H_
#define _ADMINWRAP_H_

#pragma warning( disable : 4310 4244)// Disable warning messages for level 4
#include <comdef.h>
#pragma warning( default : 4310 4244)

#include <comadmin.h>
#include "macro.h"
typedef enum
{
	APPLICATION=0,
	COMPONENT,
	SUBSCRIPTION,
	TRANSIENTSUB,
	PUBPROP,
	TRANSIENTPUBPROP,
} ADMINTYPE, *PADMINTYPE;

class CApp 
{
public:
	CApp();
	CApp(ICOMAdminCatalog* pAdminCatalog, WCHAR* pwzAppName);
	virtual ~CApp();

	HRESULT SetProperties(ICOMAdminCatalog* pAdminCatalog, WCHAR*);
	HRESULT CreateApp(BOOL fServer = FALSE, BOOL fQueued = FALSE);
	HRESULT DeleteApp(void);
	HRESULT InstallComponent(WCHAR* pwzcompdllname);
	HRESULT RemoveComponent(WCHAR* progid);
	HRESULT AddEventClass(WCHAR* pwzdllname, WCHAR* pwztlbpath, WCHAR* pwzCompName, WCHAR* pwzPublisherID, WCHAR* pwzFilterCLSID, BOOL fAllowinproc, BOOL fFireinparallel);
	HRESULT AddSubscription(WCHAR* pwzProgID, WCHAR* pwzSubName, WCHAR* pwzECID, WCHAR* pwzPubID, WCHAR* pwzIID, WCHAR* pwzMethod, WCHAR* pwzCriteria, WCHAR* pwzPubProp, WCHAR* pwzPubVal);
	HRESULT RemoveSubscription(WCHAR* pwzProgID, WCHAR* pwzSubName);
	HRESULT SetProperty(ADMINTYPE type, WCHAR* pwztypename, WCHAR* pwztypename2, WCHAR* pwzPropName, VARIANT& var);
   WCHAR*  GetAppName() { return m_pwzAppName; }

	static HRESULT AddTransientSubscription(WCHAR* pwzSubName,CLSID clsidEventClass, WCHAR* pwzPubID,IID iidInterface, IUnknown *punk, WCHAR* pwzMethod, WCHAR* pwzCriteria, WCHAR* pwzPubProp, WCHAR* pwzPubVal);
	static HRESULT AddTransientSubscription(WCHAR* pwzSubName,CLSID clsidEventClass,IID iidInterface, IUnknown *punk);
	static HRESULT RemoveTransientSubscription(WCHAR* pwzName);

private:
	WCHAR*            m_pwzAppName;
	ICOMAdminCatalog* m_pAdminCatalog;
};


// Catalogue access functions
HRESULT GetObjectAndCollection(ICOMAdminCatalog* pCat, BSTR szCollName, BSTR szObjectName, ADMINTYPE type, ICatalogCollection** ppCol, ICatalogObject** ppObj);
HRESULT GetObjectAndCollection(ICatalogCollection* pParentColl, ICatalogObject* pParentObject, BSTR szCollName, BSTR szObjectName, ADMINTYPE type, ICatalogCollection** ppCol, ICatalogObject** ppObj);
HRESULT RemoveNamedObjectFromCollection(ICatalogCollection* pCol, BSTR szObjectName, ADMINTYPE type);
HRESULT GetNamedObjectFromCollection(ICatalogCollection* pCol, BSTR szObjName, ICatalogObject** ppCatObj, LONG* plIndex, ADMINTYPE type, BSTR bstrName=NULL);
HRESULT GetCollection(ICOMAdminCatalog* pCat, BSTR szCollName, ICatalogCollection** ppCol);
HRESULT GetCollection(ICatalogCollection* pParentColl, ICatalogObject* pCatObj, BSTR szCollName, ICatalogCollection** ppCol);
HRESULT GetObjectNameProperty(ADMINTYPE type, BSTR* pbstr);
HRESULT SetStringProperty(ICatalogObject *pcat, BSTR bPROP, WCHAR* pval);
HRESULT SetIUnknownProperty(ICatalogObject *pcat, BSTR bPROP, IUnknown* punk);
HRESULT SetBoolProperty(ICatalogObject *pcat, BSTR bPROP, BOOL fFlag);

#endif
